#include <stdio.h>

__attribute__((destructor)) void dtor(void) {
  puts("dtor");
}

__attribute__((constructor)) void ctor(void) {
  puts("ctor");
}

__attribute__((constructor)) void ctor2(void) {
  puts("ctor2");
}

__attribute__((destructor)) void dtor2(void) {
  puts("dtor2");
}

extern char __CTOR_LIST__;
extern char __CTOR_END__;
extern char __DTOR_LIST__;
extern char __DTOR_END__;

int main() {
  printf("%p %p %d\n",&__CTOR_LIST__,&__CTOR_END__,&__CTOR_END__-&__CTOR_LIST__);
  printf("%p %p %d\n",&__DTOR_LIST__,&__DTOR_END__,&__DTOR_END__-&__DTOR_LIST__);
  puts("main");
}
